package bitsplease.mummymayhem.model;

public enum PhaseType {

    PLAYER_A_BUILD,
    PLAYER_B_BUILD,
    ATTACK;

    private static int playerPriority = 0;
    private static int roundState = 0;

    /**
     * Returns the next phase type.
     * Alternates players' order when it switches to attack phase.
     *
     * @return the next type if current isn't the last in values array, first type otherwise
     */
    public static PhaseType nextPhase(){

        roundState = (roundState + 1) % PhaseType.values().length;
        if (roundState == 2)    changePlayerPriority();

        int nextIndex;

        switch (roundState) {
            case 0 -> nextIndex = playerPriority;
            case 1 -> nextIndex = playerPriority == 0 ? 1 : 0;
            default -> nextIndex = roundState;
        }

        return PhaseType.values()[nextIndex];
    }

    /**
     * Method which needs to be called when starting a new game.
     */
    public static void reset(){
        playerPriority = 0;
        roundState = 0;
    }

    /**
     * Sets the player priority for the next round.
     */
    private static void changePlayerPriority() {
        playerPriority = playerPriority == 0 ? 1 : 0;
    }
}
