package bitsplease.mummymayhem.model.buildings;

import bitsplease.mummymayhem.model.utils.Sprite;
import javafx.geometry.Point2D;

public abstract class Building extends Sprite {

    protected int hp;

    protected Building(Point2D position, String imagePath) {
        super(position, imagePath);
    }

    public void setHp(int hp) {
        this.hp = hp;
    }

    public int getHp() {
        return hp;
    }

    /**
     * Decreases the building's hp with the given value,
     * or sets hp to 0 if the value is bigger than current hp.
     *
     * @param damage The value of the incoming damage
     */
    public void takeDamage(int damage) {
        if (hp <= damage) {
            hp = 0;
        }
        else {
            hp -= damage;
        }
    }

    /**
     * Checks if building still has some hp.
     *
     * @return true if hp is bigger than 0, false otherwise
     */
    public boolean isAlive() {
        return hp > 0;
    }
}
