package bitsplease.mummymayhem.model.buildings;

public enum TowerType {

    GUARDIAN(5, 50, 3, 450, "src/main/resources/assets/buildings/tower3.png", UpgradeType.RANGE),
    BLOCKADE(5, 100, 1, 480, "src/main/resources/assets/buildings/tower1.png", UpgradeType.HP),
    DESTROYER(7, 70, 2, 500, "src/main/resources/assets/buildings/tower2.png", UpgradeType.ATTACK);

    private final String imagePath;
    private final int attack;
    private final int hp;
    private final int range;
    private final int price;
    private final UpgradeType upgradeType;

    TowerType(int attack, int hp, int range, int price, String imagePath, UpgradeType upgradeType) {
        this.attack = attack;
        this.hp = hp;
        this.range = range;
        this.price = price;
        this.imagePath = imagePath;
        this.upgradeType = upgradeType;
    }

    public String getImagePath() {
        return imagePath;
    }

    public int getAttack() {
        return attack;
    }

    public int getHp() {
        return hp;
    }

    public int getRange() {
        return range;
    }

    public int getPrice() {
        return price;
    }

    public UpgradeType getUpgradeType() { return upgradeType; }
}
