package bitsplease.mummymayhem.model.units;

import bitsplease.mummymayhem.model.buildings.Building;
import javafx.geometry.Point2D;

public class Demolisher extends Unit{
    private static final int BASE_HP=50;
    private static final int ATTACK_VALUE=25;
    private static final int BUILDING_ATTACK_VALUE=2;
    private static final int SPEED_VALUE=3;
    private static final int PRICE=150;

    public Demolisher(Point2D position, String imagePath) {
        super(position, imagePath, BASE_HP, SPEED_VALUE, ATTACK_VALUE, PRICE);
    }

    public Demolisher(Unit unit) {
        super(unit);
    }

    public String getName() {
        return "Demolisher";
    }

    /**
     * Attacks the target building(Barrack, Castle), decreasing its health by the unit's attack value
     *
     * @param building The target building
     */
    @Override
    public void attack(Building building) {
        building.takeDamage(BUILDING_ATTACK_VALUE);
    }
}
