package bitsplease.mummymayhem.model.utils;

import bitsplease.mummymayhem.model.map.Field;
import bitsplease.mummymayhem.model.map.FieldType;
import javafx.geometry.Point2D;

import java.util.ArrayList;
import java.util.List;

public class ClimberPathFinder extends PathFinder{

    public ClimberPathFinder(int width, int height, Point2D start, Point2D destination, List<List<Field>> fields) {
        super(width, height, start, destination, fields);
    }

    /**
     * Adds open fields to 'allNodes'.
     *
     * @param fields The map's fields.
     */
    @Override
    protected void setFreeNodes(List<List<Field>> fields) {

        allNodes = new ArrayList<>();
        for (int i = 0; i < WIDTH; i++) {
            for (int j = 0; j < HEIGHT; j++) {
                if (fields.get(i).get(j).getType() == FieldType.DUNE
                        || fields.get(i).get(j).getPosition().equals(DESTINATION)
                        || !fields.get(i).get(j).isOccupied()) {
                    allNodes.add(new Point2D(i, j));
                }
            }
        }
    }
}
