package bitsplease.mummymayhem.model.utils;

import javafx.scene.image.Image;
import java.util.Map;

public class ImageStorage {

    private static final Map<String, Image> storage = Map.<String, Image>ofEntries(
            //buildings
            Map.entry("src/main/resources/assets/buildings/tower1.png", ResourceLoader.loadImage("src/main/resources/assets/buildings/tower1.png")),
            Map.entry("src/main/resources/assets/buildings/tower2.png", ResourceLoader.loadImage("src/main/resources/assets/buildings/tower2.png")),
            Map.entry("src/main/resources/assets/buildings/tower3.png", ResourceLoader.loadImage("src/main/resources/assets/buildings/tower3.png")),
            Map.entry("src/main/resources/assets/buildings/tower-projectile.png", ResourceLoader.loadImage("src/main/resources/assets/buildings/tower-projectile.png")),
            Map.entry("src/main/resources/assets/buildings/ruined-tower.png", ResourceLoader.loadImage("src/main/resources/assets/buildings/ruined-tower.png")),
            Map.entry("src/main/resources/assets/buildings/barrack.png", ResourceLoader.loadImage("src/main/resources/assets/buildings/barrack.png")),
            //fields
            Map.entry("src/main/resources/assets/fields/openField.png", ResourceLoader.loadImage("src/main/resources/assets/fields/openField.png")),
            Map.entry("src/main/resources/assets/fields/duneField.png", ResourceLoader.loadImage("src/main/resources/assets/fields/duneField.png")),
            Map.entry("src/main/resources/assets/fields/cactusField.png", ResourceLoader.loadImage("src/main/resources/assets/fields/cactusField.png")),
            Map.entry("src/main/resources/assets/fields/cactusField2.png", ResourceLoader.loadImage("src/main/resources/assets/fields/cactusField2.png")),
            Map.entry("src/main/resources/assets/fields/stoneField.png", ResourceLoader.loadImage("src/main/resources/assets/fields/stoneField.png")),
            Map.entry("src/main/resources/assets/fields/stoneField2.png", ResourceLoader.loadImage("src/main/resources/assets/fields/stoneField2.png")),
            Map.entry("src/main/resources/assets/fields/treeField.png", ResourceLoader.loadImage("src/main/resources/assets/fields/treeField.png")),
            Map.entry("src/main/resources/assets/fields/treeField2.png", ResourceLoader.loadImage("src/main/resources/assets/fields/treeField2.png")),
            //castles
            Map.entry("src/main/resources/assets/pyramids/playerA_pyramid.png", ResourceLoader.loadImage("src/main/resources/assets/pyramids/playerA_pyramid.png")),
            Map.entry("src/main/resources/assets/pyramids/playerB_pyramid.png", ResourceLoader.loadImage("src/main/resources/assets/pyramids/playerB_pyramid.png")),
            //units
            Map.entry("src/main/resources/assets/units/demolisher/down_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/down_1.png")),
            Map.entry("src/main/resources/assets/units/demolisher/down_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/down_2.png")),
            Map.entry("src/main/resources/assets/units/demolisher/down_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/down_3.png")),
            Map.entry("src/main/resources/assets/units/demolisher/left_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/left_1.png")),
            Map.entry("src/main/resources/assets/units/demolisher/left_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/left_2.png")),
            Map.entry("src/main/resources/assets/units/demolisher/left_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/left_3.png")),
            Map.entry("src/main/resources/assets/units/demolisher/right_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/right_1.png")),
            Map.entry("src/main/resources/assets/units/demolisher/right_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/right_2.png")),
            Map.entry("src/main/resources/assets/units/demolisher/right_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/right_3.png")),
            Map.entry("src/main/resources/assets/units/demolisher/up_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/up_1.png")),
            Map.entry("src/main/resources/assets/units/demolisher/up_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/up_2.png")),
            Map.entry("src/main/resources/assets/units/demolisher/up_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/demolisher/up_3.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/down_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/down_1.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/down_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/down_2.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/down_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/down_3.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/left_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/left_1.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/left_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/left_2.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/left_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/left_3.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/right_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/right_1.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/right_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/right_2.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/right_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/right_3.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/up_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/up_1.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/up_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/up_2.png")),
            Map.entry("src/main/resources/assets/units/duneClimber/up_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/duneClimber/up_3.png")),
            Map.entry("src/main/resources/assets/units/fighter/down_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/down_1.png")),
            Map.entry("src/main/resources/assets/units/fighter/down_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/down_2.png")),
            Map.entry("src/main/resources/assets/units/fighter/down_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/down_3.png")),
            Map.entry("src/main/resources/assets/units/fighter/left_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/left_1.png")),
            Map.entry("src/main/resources/assets/units/fighter/left_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/left_2.png")),
            Map.entry("src/main/resources/assets/units/fighter/left_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/left_3.png")),
            Map.entry("src/main/resources/assets/units/fighter/right_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/right_1.png")),
            Map.entry("src/main/resources/assets/units/fighter/right_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/right_2.png")),
            Map.entry("src/main/resources/assets/units/fighter/right_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/right_3.png")),
            Map.entry("src/main/resources/assets/units/fighter/up_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/up_1.png")),
            Map.entry("src/main/resources/assets/units/fighter/up_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/up_2.png")),
            Map.entry("src/main/resources/assets/units/fighter/up_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/fighter/up_3.png")),
            Map.entry("src/main/resources/assets/units/runner/down_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/down_1.png")),
            Map.entry("src/main/resources/assets/units/runner/down_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/down_2.png")),
            Map.entry("src/main/resources/assets/units/runner/down_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/down_3.png")),
            Map.entry("src/main/resources/assets/units/runner/left_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/left_1.png")),
            Map.entry("src/main/resources/assets/units/runner/left_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/left_2.png")),
            Map.entry("src/main/resources/assets/units/runner/left_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/left_3.png")),
            Map.entry("src/main/resources/assets/units/runner/right_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/right_1.png")),
            Map.entry("src/main/resources/assets/units/runner/right_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/right_2.png")),
            Map.entry("src/main/resources/assets/units/runner/right_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/right_3.png")),
            Map.entry("src/main/resources/assets/units/runner/up_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/up_1.png")),
            Map.entry("src/main/resources/assets/units/runner/up_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/up_2.png")),
            Map.entry("src/main/resources/assets/units/runner/up_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/runner/up_3.png")),
            Map.entry("src/main/resources/assets/units/tank/down_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/down_1.png")),
            Map.entry("src/main/resources/assets/units/tank/down_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/down_2.png")),
            Map.entry("src/main/resources/assets/units/tank/down_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/down_3.png")),
            Map.entry("src/main/resources/assets/units/tank/left_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/left_1.png")),
            Map.entry("src/main/resources/assets/units/tank/left_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/left_2.png")),
            Map.entry("src/main/resources/assets/units/tank/left_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/left_3.png")),
            Map.entry("src/main/resources/assets/units/tank/right_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/right_1.png")),
            Map.entry("src/main/resources/assets/units/tank/right_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/right_2.png")),
            Map.entry("src/main/resources/assets/units/tank/right_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/right_3.png")),
            Map.entry("src/main/resources/assets/units/tank/up_1.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/up_1.png")),
            Map.entry("src/main/resources/assets/units/tank/up_2.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/up_2.png")),
            Map.entry("src/main/resources/assets/units/tank/up_3.png", ResourceLoader.loadImage("src/main/resources/assets/units/tank/up_3.png")),
            //hp bars
            Map.entry("src/main/resources/assets/images/health-bar-bg.png", ResourceLoader.loadImage("src/main/resources/assets/images/health-bar-bg.png")),
            Map.entry("src/main/resources/assets/images/health-bar-playerA.png", ResourceLoader.loadImage("src/main/resources/assets/images/health-bar-playerA.png")),
            Map.entry("src/main/resources/assets/images/health-bar-playerB.png", ResourceLoader.loadImage("src/main/resources/assets/images/health-bar-playerB.png"))
    );

    public static Image getImage(Sprite sprite) {
        return storage.get(sprite.getImagePath());
    }

    public static Image getImage(String path) {
        return storage.get(path);
    }
}
