package bitsplease.mummymayhem.model.utils;

import javafx.scene.media.AudioClip;

import java.util.Map;

public class SFXStorage {

    private static final Map<SFXType, AudioClip> sfxStorage = Map.ofEntries(
            //Main
            Map.entry(SFXType.BUTTON_CLICK, ResourceLoader.loadSFX("src/main/resources/sfx/button_click.wav")),
            //GameState
            Map.entry(SFXType.GAME_END_VICTORY, ResourceLoader.loadSFX("src/main/resources/sfx/game/victory.wav")),
            Map.entry(SFXType.GAME_END_DRAW, ResourceLoader.loadSFX("src/main/resources/sfx/game/draw.wav")),
            Map.entry(SFXType.BATTLE_PHASE_START, ResourceLoader.loadSFX("src/main/resources/sfx/game/battle_start.wav")),
            Map.entry(SFXType.BATTLE_PHASE_END, ResourceLoader.loadSFX("src/main/resources/sfx/game/battle_end.wav")),
            //Tower
            Map.entry(SFXType.TOWER_ATTACK, ResourceLoader.loadSFX("src/main/resources/sfx/tower/attack.wav")),
            Map.entry(SFXType.TOWER_PLACEMENT, ResourceLoader.loadSFX("src/main/resources/sfx/tower/placement.wav")),
            Map.entry(SFXType.TOWER_UPGRADE, ResourceLoader.loadSFX("src/main/resources/sfx/tower/upgrade.wav")),
            Map.entry(SFXType.TOWER_DEMOLISH, ResourceLoader.loadSFX("src/main/resources/sfx/tower/demolish.wav")),
            Map.entry(SFXType.TOWER_DESTROY, ResourceLoader.loadSFX("src/main/resources/sfx/tower/destroy.wav")),
            //Unit
            Map.entry(SFXType.UNIT_BUY, ResourceLoader.loadSFX("src/main/resources/sfx/unit/buy.wav")),
            Map.entry(SFXType.UNIT_SELL, ResourceLoader.loadSFX("src/main/resources/sfx/unit/sell.wav")),
            Map.entry(SFXType.UNIT_DEATH, ResourceLoader.loadSFX("src/main/resources/sfx/unit/death.wav")),
            Map.entry(SFXType.UNIT_DEATH_RARE, ResourceLoader.loadSFX("src/main/resources/sfx/unit/wilhelm.wav")),
            Map.entry(SFXType.UNIT_ATTACK, ResourceLoader.loadSFX("src/main/resources/sfx/unit/attack.wav")),
            Map.entry(SFXType.UNIT_VOICE, ResourceLoader.loadSFX("src/main/resources/sfx/unit/bruh.wav"))

    );

    public static AudioClip getSFX(SFXType type) {return sfxStorage.get(type) ; }

}
