package bitsplease.mummymayhem.model.buildings;

import javafx.geometry.Point2D;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class BarrackTest {

    private static final int PRICE = 100;

    Barrack barrack;

    @BeforeEach
    void setUp() {
        barrack = new Barrack(new Point2D(0, 0));
    }

    @Test
    void takeDamageTest() {
        barrack.takeDamage(15);
        Assertions.assertEquals(35, barrack.getHp());
    }

    @Test
    void isAliveTest() {
        barrack.takeDamage(15);
        Assertions.assertTrue(barrack.isAlive());
    }

    @Test
    void isAliveTest2() {
        barrack.takeDamage(50);
        Assertions.assertFalse(barrack.isAlive());
    }

    @Test
    void isAliveTest3() {
        barrack.takeDamage(51);
        Assertions.assertFalse(barrack.isAlive());
    }

    @Test
    void getPriceTest() {
        Assertions.assertEquals(PRICE, Barrack.getPrice());
    }

    @Test
    void getPositionTest() {
        Assertions.assertEquals(new Point2D(0, 0), barrack.getPosition());
    }

    @Test
    void setPositionTest() {
        barrack.setPosition(new Point2D(3, 5));
        Assertions.assertEquals(new Point2D(3, 5), barrack.getPosition());
    }

    @Test
    void setImagePathTest() {
        barrack.setImagePath("src/test.png");
        Assertions.assertEquals("src/test.png", barrack.getImagePath());
    }

}
