package bitsplease.mummymayhem.model.buildings;

import javafx.geometry.Point2D;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class CastleTest {

    Castle castle;

    @BeforeEach
    void setUp() {
        castle = new Castle(new Point2D(0, 0), "test.png");
    }

    @Test
    void takeDamageTest() {
        castle.takeDamage(15);
        Assertions.assertEquals(85, castle.getHp());
    }

    @Test
    void isAliveTest() {
        castle.takeDamage(15);
        Assertions.assertTrue(castle.isAlive());
    }

    @Test
    void isAliveTest2() {
        castle.takeDamage(100);
        Assertions.assertFalse(castle.isAlive());
    }

    @Test
    void isAliveTest3() {
        castle.takeDamage(101);
        Assertions.assertFalse(castle.isAlive());
    }

    @Test
    void getPositionTest() {
        Assertions.assertEquals(new Point2D(0, 0), castle.getPosition());
    }

    @Test
    void setPositionTest() {
        castle.setPosition(new Point2D(3, 5));
        Assertions.assertEquals(new Point2D(3, 5), castle.getPosition());
    }

    @Test
    void setImagePathTest() {
        castle.setImagePath("src/test.txt");
        Assertions.assertEquals("src/test.txt", castle.getImagePath());
    }
}
