package bitsplease.mummymayhem.model.map;

import bitsplease.mummymayhem.model.buildings.Castle;
import bitsplease.mummymayhem.model.buildings.Tower;
import bitsplease.mummymayhem.model.buildings.TowerType;
import javafx.geometry.Point2D;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

class FieldTest {
    Field field;

    @BeforeEach
    void setUp() {
        field = new Field(new Point2D(0,0), FieldType.OPEN);
    }

    @Test
    void isOccupied() {
        Assertions.assertFalse(field.isOccupied());

        field.addTower(new Tower(new Point2D(0,0), TowerType.BLOCKADE));
        Assertions.assertTrue(field.isOccupied());
        field.removeTower();

        field.addBuilding(new Castle(new Point2D(0,0), ""));
        Assertions.assertTrue(field.isOccupied());
    }

    @Test
    void hasTower() {
        Assertions.assertFalse(field.hasTower());

        field.addTower(new Tower(new Point2D(0,0), TowerType.BLOCKADE));
        Assertions.assertTrue(field.hasTower());
    }

    @Test
    void hasBuilding() {
        Assertions.assertFalse(field.hasBuilding());

        field.addBuilding(new Castle(new Point2D(0,0), ""));
        Assertions.assertTrue(field.hasBuilding());
    }
}